=== modified file 'drizzled/dtcollation.cc'
--- drizzled/dtcollation.cc	2009-02-09 19:20:19 +0000
+++ drizzled/dtcollation.cc	2009-05-15 19:17:03 +0000
@@ -28,31 +28,10 @@
 #include <drizzled/session.h>
 
 
-static bool
-left_is_superset(const DTCollation &left, const DTCollation &right)
-{
-  /* Allow convert to Unicode */
-  if (left.collation->state & MY_CS_UNICODE &&
-      (left.derivation < right.derivation ||
-       (left.derivation == right.derivation &&
-        !(right.collation->state & MY_CS_UNICODE))))
-    return true;
-  /* Allow convert from ASCII */
-  if (right.repertoire == MY_REPERTOIRE_ASCII &&
-      (left.derivation < right.derivation ||
-       (left.derivation == right.derivation &&
-        !(left.repertoire == MY_REPERTOIRE_ASCII))))
-    return true;
-  /* Disallow conversion otherwise */
-  return false;
-}
-
-
 DTCollation::DTCollation()
 {
   collation= &my_charset_bin;
   derivation= DERIVATION_NONE;
-  repertoire= MY_REPERTOIRE_UNICODE30;
 }
 
 
@@ -61,12 +40,6 @@
 {
   collation= collation_arg;
   derivation= derivation_arg;
-  set_repertoire_from_charset(collation_arg);
-}
-void DTCollation::set_repertoire_from_charset(const CHARSET_INFO * const cs)
-{
-  repertoire= cs->state & MY_CS_PUREASCII ?
-    MY_REPERTOIRE_ASCII : MY_REPERTOIRE_UNICODE30;
 }
 
 
@@ -74,7 +47,6 @@
 {
   collation= dt.collation;
   derivation= dt.derivation;
-  repertoire= dt.repertoire;
 }
 
 
@@ -83,24 +55,12 @@
 {
   collation= collation_arg;
   derivation= derivation_arg;
-  set_repertoire_from_charset(collation_arg);
-}
-
-
-void DTCollation::set(const CHARSET_INFO * const collation_arg,
-                      Derivation derivation_arg,
-                      uint32_t repertoire_arg)
-{
-  collation= collation_arg;
-  derivation= derivation_arg;
-  repertoire= repertoire_arg;
 }
 
 
 void DTCollation::set(const CHARSET_INFO * const collation_arg)
 {
   collation= collation_arg;
-  set_repertoire_from_charset(collation_arg);
 }
 
 
@@ -141,12 +101,18 @@
       }
     }
     else if ((flags & MY_COLL_ALLOW_SUPERSET_CONV) &&
-             left_is_superset(*this, dt))
+             collation->state & MY_CS_UNICODE &&
+             (derivation < dt.derivation ||
+              (derivation == dt.derivation &&
+               !(dt.collation->state & MY_CS_UNICODE))))
     {
       // Do nothing
     }
     else if ((flags & MY_COLL_ALLOW_SUPERSET_CONV) &&
-             left_is_superset(dt, *this))
+             dt.collation->state & MY_CS_UNICODE &&
+             (dt.derivation < derivation ||
+              (dt.derivation == derivation &&
+               !(collation->state & MY_CS_UNICODE))))
     {
       set(dt);
     }
@@ -165,8 +131,8 @@
     else
     {
       // Cannot apply conversion
-      set(0, DERIVATION_NONE, 0);
-      return 1;
+      set(0, DERIVATION_NONE);
+      return true;
     }
   }
   else if (derivation < dt.derivation)
@@ -187,22 +153,22 @@
     {
       if (derivation == DERIVATION_EXPLICIT)
       {
-        set(0, DERIVATION_NONE, 0);
-        return 1;
+        set(0, DERIVATION_NONE);
+        return true;
       }
       if (collation->state & MY_CS_BINSORT)
-        return 0;
+        return false;
       if (dt.collation->state & MY_CS_BINSORT)
       {
         set(dt);
-        return 0;
+        return false;
       }
       const CHARSET_INFO * const bin= get_charset_by_csname(collation->csname, MY_CS_BINSORT);
       set(bin, DERIVATION_NONE);
     }
   }
-  repertoire|= dt.repertoire;
-  return 0;
+
+  return false;
 }
 
 
@@ -296,11 +262,7 @@
                                   &dummy_offset))
       continue;
 
-    if (!(conv= (*arg)->safe_charset_converter(coll.collation)) &&
-        ((*arg)->collation.repertoire == MY_REPERTOIRE_ASCII))
-      conv= new Item_func_conv_charset(*arg, coll.collation, 1);
-
-    if (!conv)
+    if (!(conv= (*arg)->safe_charset_converter(coll.collation)))
     {
       if (nargs >=2 && nargs <= 3)
       {

=== modified file 'drizzled/dtcollation.h'
--- drizzled/dtcollation.h	2008-11-14 23:27:02 +0000
+++ drizzled/dtcollation.h	2009-05-15 19:17:03 +0000
@@ -32,9 +32,6 @@
 public:
   const CHARSET_INFO *collation;
   enum Derivation derivation;
-  uint32_t repertoire;
-
-  void set_repertoire_from_charset(const CHARSET_INFO * const cs);
 
   DTCollation();
   DTCollation(const CHARSET_INFO * const collation_arg,
@@ -42,9 +39,6 @@
   void set(DTCollation &dt);
   void set(const CHARSET_INFO * const collation_arg,
            Derivation derivation_arg);
-  void set(const CHARSET_INFO * const collation_arg,
-           Derivation derivation_arg,
-           uint32_t repertoire_arg);
   void set(const CHARSET_INFO * const collation_arg);
   void set(Derivation derivation_arg);
   bool set(DTCollation &dt1, DTCollation &dt2, uint32_t flags= 0);

=== modified file 'drizzled/function/str/set_collation.cc'
--- drizzled/function/str/set_collation.cc	2009-02-09 19:20:19 +0000
+++ drizzled/function/str/set_collation.cc	2009-05-15 19:17:03 +0000
@@ -56,8 +56,7 @@
              colname, args[0]->collation.collation->csname);
     return;
   }
-  collation.set(set_collation, DERIVATION_EXPLICIT,
-                args[0]->collation.repertoire);
+  collation.set(set_collation, DERIVATION_EXPLICIT);
   max_length= args[0]->max_length;
 }
 

=== modified file 'drizzled/function/time/date_format.cc'
--- drizzled/function/time/date_format.cc	2009-02-28 17:49:22 +0000
+++ drizzled/function/time/date_format.cc	2009-05-15 19:17:03 +0000
@@ -261,10 +261,7 @@
 
   decimals=0;
   const CHARSET_INFO * const cs= session->variables.getCollation();
-  uint32_t repertoire= arg1->collation.repertoire;
-  if (!session->variables.lc_time_names->is_ascii)
-    repertoire|= MY_REPERTOIRE_EXTENDED;
-  collation.set(cs, arg1->collation.derivation, repertoire);
+  collation.set(cs, arg1->collation.derivation);
   if (arg1->type() == STRING_ITEM)
   {                                             // Optimize the normal case
     fixed_length=1;

=== modified file 'drizzled/item/create.cc'
--- drizzled/item/create.cc	2009-04-24 20:07:58 +0000
+++ drizzled/item/create.cc	2009-05-15 19:17:03 +0000
@@ -2711,12 +2711,12 @@
   if (cs->mbminlen > 1)
   {
     uint32_t dummy_errors;
-    sp= new (session->mem_root) Item_string("", 0, cs, DERIVATION_COERCIBLE, MY_REPERTOIRE_ASCII);
+    sp= new (session->mem_root) Item_string("", 0, cs, DERIVATION_COERCIBLE);
     sp->str_value.copy(" ", 1, &my_charset_utf8_general_ci, cs, &dummy_errors);
   }
   else
   {
-    sp= new (session->mem_root) Item_string(" ", 1, cs, DERIVATION_COERCIBLE, MY_REPERTOIRE_ASCII);
+    sp= new (session->mem_root) Item_string(" ", 1, cs, DERIVATION_COERCIBLE);
   }
 
   return new (session->mem_root) Item_func_repeat(sp, arg1);

=== modified file 'drizzled/item/string.h'
--- drizzled/item/string.h	2009-05-15 01:47:27 +0000
+++ drizzled/item/string.h	2009-05-15 19:17:03 +0000
@@ -26,12 +26,11 @@
 {
 public:
   Item_string(const char *str,uint32_t length,
-              const CHARSET_INFO * const cs, Derivation dv= DERIVATION_COERCIBLE,
-              uint32_t repertoire= MY_REPERTOIRE_UNICODE30)
+              const CHARSET_INFO * const cs, Derivation dv= DERIVATION_COERCIBLE)
     : m_cs_specified(false)
   {
     str_value.set_or_copy_aligned(str, length, cs);
-    collation.set(cs, dv, repertoire);
+    collation.set(cs, dv);
     /*
       We have to have a different max_length than 'length' here to
       ensure that we get the right length if we do use the item
@@ -56,24 +55,17 @@
     fixed= 1;
   }
   Item_string(const char *name_par, const char *str, uint32_t length,
-              const CHARSET_INFO * const cs, Derivation dv= DERIVATION_COERCIBLE,
-              uint32_t repertoire= MY_REPERTOIRE_UNICODE30)
+              const CHARSET_INFO * const cs, Derivation dv= DERIVATION_COERCIBLE)
     : m_cs_specified(false)
   {
     str_value.set_or_copy_aligned(str, length, cs);
-    collation.set(cs, dv, repertoire);
+    collation.set(cs, dv);
     max_length= str_value.numchars()*cs->mbmaxlen;
     set_name(name_par, 0, cs);
     decimals=NOT_FIXED_DEC;
     // it is constant => can be used without fix_fields (and frequently used)
     fixed= 1;
   }
-  void set_repertoire_from_value()
-  {
-    collation.repertoire= my_string_repertoire(str_value.charset(),
-                                               str_value.ptr(),
-                                               str_value.length());
-  }
   enum Type type() const { return STRING_ITEM; }
   double val_real();
   int64_t val_int();

=== modified file 'drizzled/session.cc'
--- drizzled/session.cc	2009-05-15 07:39:56 +0000
+++ drizzled/session.cc	2009-05-15 19:17:03 +0000
@@ -2099,7 +2099,7 @@
     entry->value=0;
     entry->length=0;
     entry->update_query_id=0;
-    entry->collation.set(NULL, DERIVATION_IMPLICIT, 0);
+    entry->collation.set(NULL, DERIVATION_IMPLICIT);
     entry->unsigned_flag= 0;
     /*
       If we are here, we were called from a SET or a query which sets a

=== modified file 'drizzled/sql_yacc.yy'
--- drizzled/sql_yacc.yy	2009-05-15 07:55:30 +0000
+++ drizzled/sql_yacc.yy	2009-05-15 19:17:03 +0000
@@ -5160,33 +5160,14 @@
 /* Common definitions */
 
 text_literal:
-          TEXT_STRING
-          {
-            LEX_STRING tmp;
-            Session *session= YYSession;
-            const CHARSET_INFO * const cs_con= session->variables.getCollation();
-            const CHARSET_INFO * const cs_cli= default_charset_info;
-            uint32_t repertoire= session->lex->text_string_is_7bit &&
-                             my_charset_is_ascii_based(cs_cli) ?
-                             MY_REPERTOIRE_ASCII : MY_REPERTOIRE_UNICODE30;
-            tmp= $1;
-            $$= new Item_string(tmp.str, tmp.length, cs_con, DERIVATION_COERCIBLE, repertoire);
-          }
+        TEXT_STRING_literal
+        {
+          Session *session= YYSession;
+          $$ = new Item_string($1.str, $1.length, session->variables.getCollation());
+        }
         | text_literal TEXT_STRING_literal
-          {
-            Item_string* item= (Item_string*) $1;
-            item->append($2.str, $2.length);
-            if (!(item->collation.repertoire & MY_REPERTOIRE_EXTENDED))
-            {
-              /*
-                 If the string has been pure ASCII so far,
-                 check the new part.
-              */
-              const CHARSET_INFO * const cs= YYSession->variables.getCollation();
-              item->collation.repertoire|= my_string_repertoire(cs,
-                                                                $2.str,
-                                                                $2.length);
-            }
+          { 
+            ((Item_string*) $1)->append($2.str, $2.length); 
           }
         ;
 

=== modified file 'mystrings/ctype.cc'
--- mystrings/ctype.cc	2008-12-16 02:39:00 +0000
+++ mystrings/ctype.cc	2009-05-15 19:17:03 +0000
@@ -60,110 +60,3 @@
   CHARSET_INFO cs;
   int (*add_collation)(CHARSET_INFO *cs);
 } MY_CHARSET_LOADER;
-
-
-
-/*
-  Check repertoire: detect pure ascii strings
-*/
-uint
-my_string_repertoire(const CHARSET_INFO * const cs, const char *str, ulong length)
-{
-  const char *strend= str + length;
-  if (cs->mbminlen == 1)
-  {
-    for ( ; str < strend; str++)
-    {
-      if (((unsigned char) *str) > 0x7F)
-        return MY_REPERTOIRE_UNICODE30;
-    }
-  }
-  else
-  {
-    my_wc_t wc;
-    int chlen;
-    for (; (chlen= cs->cset->mb_wc(cs, &wc, (unsigned char *)str, (unsigned char *)strend)) > 0; str+= chlen)
-    {
-      if (wc > 0x7F)
-        return MY_REPERTOIRE_UNICODE30;
-    }
-  }
-  return MY_REPERTOIRE_ASCII;
-}
-
-
-/*
-  Detect whether a character set is ASCII compatible.
-
-  Returns true for:
-
-  - all 8bit character sets whose Unicode mapping of 0x7B is '{'
-    (ignores swe7 which maps 0x7B to "LATIN LETTER A WITH DIAERESIS")
-
-  - all multi-byte character sets having mbminlen == 1
-    (ignores ucs2 whose mbminlen is 2)
-
-  TODO:
-
-  When merging to 5.2, this function should be changed
-  to check a new flag MY_CS_NONASCII,
-
-     return (cs->flag & MY_CS_NONASCII) ? 0 : 1;
-
-  This flag was previously added into 5.2 under terms
-  of WL#3759 "Optimize identifier conversion in client-server protocol"
-  especially to mark character sets not compatible with ASCII.
-
-  We won't backport this flag to 5.0 or 5.1.
-  This function is Ok for 5.0 and 5.1, because we're not going
-  to introduce new tricky character sets between 5.0 and 5.2.
-*/
-bool
-my_charset_is_ascii_based(const CHARSET_INFO * const cs)
-{
-  return
-    (cs->mbmaxlen == 1 && cs->tab_to_uni && cs->tab_to_uni['{'] == '{') ||
-    (cs->mbminlen == 1 && cs->mbmaxlen > 1);
-}
-
-
-/*
-  Detect if a character set is 8bit,
-  and it is pure ascii, i.e. doesn't have
-  characters outside U+0000..U+007F
-  This functions is shared between "conf_to_src"
-  and dynamic charsets loader in "mysqld".
-*/
-bool
-my_charset_is_8bit_pure_ascii(const CHARSET_INFO * const cs)
-{
-  size_t code;
-  if (!cs->tab_to_uni)
-    return 0;
-  for (code= 0; code < 256; code++)
-  {
-    if (cs->tab_to_uni[code] > 0x7F)
-      return 0;
-  }
-  return 1;
-}
-
-
-/*
-  Shared function between conf_to_src and mysys.
-  Check if a 8bit character set is compatible with
-  ascii on the range 0x00..0x7F.
-*/
-bool
-my_charset_is_ascii_compatible(const CHARSET_INFO * const cs)
-{
-  uint32_t i;
-  if (!cs->tab_to_uni)
-    return 1;
-  for (i= 0; i < 128; i++)
-  {
-    if (cs->tab_to_uni[i] != i)
-      return 0;
-  }
-  return 1;
-}

=== modified file 'mystrings/m_ctype.h'
--- mystrings/m_ctype.h	2009-03-31 07:57:46 +0000
+++ mystrings/m_ctype.h	2009-05-15 19:17:03 +0000
@@ -87,15 +87,9 @@
 #define MY_CS_AVAILABLE	512    /* If either compiled-in or loaded*/
 #define MY_CS_CSSORT	1024   /* if case sensitive sort order   */
 #define MY_CS_HIDDEN	2048   /* don't display in SHOW          */
-#define MY_CS_PUREASCII 4096   /* if a charset is pure ascii     */
 #define MY_CS_NONASCII  8192   /* if not ASCII-compatible        */
 #define MY_CHARSET_UNDEFINED 0
 
-/* Character repertoire flags */
-#define MY_REPERTOIRE_ASCII      1 /* Pure ASCII            U+0000..U+007F */
-#define MY_REPERTOIRE_EXTENDED   2 /* Extended characters:  U+0080..U+FFFF */
-#define MY_REPERTOIRE_UNICODE30  3 /* ASCII | EXTENDED:     U+0000..U+FFFF */
-
 /* Flags for strxfrm */
 #define MY_STRXFRM_LEVEL1          0x00000001 /* for primary weights   */
 #define MY_STRXFRM_LEVEL2          0x00000002 /* for secondary weights */
@@ -538,11 +532,6 @@
 bool my_propagate_complex(const CHARSET_INFO * const cs, const unsigned char *str, size_t len);
 
 
-uint32_t my_string_repertoire(const CHARSET_INFO * const cs, const char *str, unsigned long len);
-bool my_charset_is_ascii_based(const CHARSET_INFO * const cs);
-bool my_charset_is_8bit_pure_ascii(const CHARSET_INFO * const cs);
-
-
 uint32_t my_strxfrm_flag_normalize(uint32_t flags, uint32_t nlevels);
 void my_strxfrm_desc_and_reverse(unsigned char *str, unsigned char *strend,
                                  uint32_t flags, uint32_t level);

